﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Plugins;
using Styx.CommonBot;
using System.Media;
using Styx;

namespace NameNotify
{
    public class NameNotify : HBPlugin
    {
        public override string Name { get { return "NameNotify"; } }
        public override string Author { get { return "Jimmy06"; } }
        public override Version Version { get { return new Version(0, 0, 0, 1); } }

        public override bool WantButton { get { return false; } }
        public override string ButtonText { get { return "Settings"; } }

        public override void  Initialize()
        {
 	         base.Initialize();

             Chat.Say += NameNotify_Say;
             Chat.Yell += NameNotify_Yell;
             Chat.Whisper += NameNotify_Whisper;
             Chat.Party += NameNotify_Party;
             Chat.PartyLeader += NameNotify_Party;
             Chat.Guild += NameNotify_Guild;
             Chat.Emote += NameNotify_Emote;
             Chat.Battleground += NameNotify_BG;
             Chat.BattlegroundLeader += NameNotify_BG;
             Chat.Raid += NameNotify_Raid;
             Chat.RaidLeader += NameNotify_Raid;
             Chat.Officer += NameNotify_Officer;
        }

        public override void Pulse()
        {

        }

        public override void Dispose()
        {
            base.Dispose();

            Chat.Say -= NameNotify_Say;
            Chat.Yell -= NameNotify_Yell;
            Chat.Whisper += NameNotify_Whisper;
            Chat.Party -= NameNotify_Party;
            Chat.PartyLeader -= NameNotify_Party;
            Chat.Guild -= NameNotify_Guild;
            Chat.Emote -= NameNotify_Emote;
            Chat.Battleground -= NameNotify_BG;
            Chat.BattlegroundLeader -= NameNotify_BG;
            Chat.Raid -= NameNotify_Raid;
            Chat.RaidLeader -= NameNotify_Raid;
            Chat.Officer -= NameNotify_Officer;
        }

        public NameNotify()
        {

        }

        private void NameNotify_Chatter(string message, string author = "", string type = "")
        {
            if (!String.IsNullOrEmpty(message))
            {
                string myname = Styx.StyxWoW.Me.Name;

                if (message.IndexOf(StyxWoW.Me.Name, 0, StringComparison.CurrentCultureIgnoreCase) != -1)
                {
                    SoundPlayer simpleSound = new SoundPlayer(@"plugins/namenotify/alert.wav");

                    simpleSound.Play();
                }

            }
        }

        private void NameNotify_Raid(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_BG(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Emote(Styx.CommonBot.Chat.ChatAuthoredEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Party(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Whisper(Styx.CommonBot.Chat.ChatWhisperEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Yell(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Say(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Guild(Styx.CommonBot.Chat.ChatGuildEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

        private void NameNotify_Officer(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            NameNotify_Chatter(e.Message, e.Author, e.EventName);
        }

    }
}
